
SET CFLAGS=/MD -DHAVE_CONFIG_H -I. -I.. /nologo
SET LIBS=..\gmp.lib bufferoverflowU.lib
 
cd tests
del /q/f/s *.obj *.dll *.exe *.lib > nul 2>&1

echo Entering directory tests
 cl %CFLAGS% -c memory.c
 cl %CFLAGS% -c misc.c
 cl %CFLAGS% -c refmpf.c
 cl %CFLAGS% -c refmpn.c
 cl %CFLAGS% -c refmpq.c
 cl %CFLAGS% -c refmpz.c
 cl %CFLAGS% -c spinner.c
 cl %CFLAGS% -c trace.c

lib /OUT:tests.lib memory.obj misc.obj refmpf.obj refmpn.obj refmpq.obj refmpz.obj spinner.obj trace.obj

cl %CFLAGS% t-bswap.c tests.lib %LIBS%
cl %CFLAGS% t-constants.c tests.lib %LIBS%
cl %CFLAGS% t-count_zeros.c tests.lib %LIBS%
cl %CFLAGS% t-gmpmax.c tests.lib %LIBS%
cl %CFLAGS% t-hightomask.c tests.lib %LIBS%
cl %CFLAGS% t-modlinv.c tests.lib %LIBS%
cl %CFLAGS% t-popc.c tests.lib %LIBS%
cl %CFLAGS% t-parity.c tests.lib %LIBS%
cl %CFLAGS% t-sub.c tests.lib %LIBS%

set path=..;..\..;%path%
t-bswap
t-constants
t-count_zeros
t-gmpmax
t-hightomask
t-modlinv
t-popc
t-parity
t-sub

cd mpn
echo Entering directory tests/mpn
cl %CFLAGS% -I../.. t-asmtype.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-aors_1.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-divrem_1.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-fat.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-get_d.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-instrument.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-iord_u.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-mp_bases.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-perfsqr.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-scan.c ..\tests.lib ..\%LIBS%

t-asmtype
t-aors_1
t-divrem_1
t-fat
t-get_d
t-instrument
t-iord_u
t-mp_bases
t-perfsqr
t-scan

cd ../mpz
echo Entering directory tests/mpz
cl %CFLAGS% -I../.. t-addsub.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-cmp.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-mul.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-mul_i.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-tdiv.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-tdiv_ui.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-fdiv.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-fdiv_ui.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-cdiv_ui.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-gcd.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-gcd_ui.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-lcm.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. dive.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. dive_ui.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-sqrtrem.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. convert.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. io.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-inp_str.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. logic.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. bit.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-powm.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-powm_ui.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-pow.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-div_2exp.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. reuse.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-root.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-perfsqr.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-jac.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-bin.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-get_d.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-get_d_2exp.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-get_si.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-set_d.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-set_si.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-fac_ui.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-fib_ui.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-lucnum_ui.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-scan.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-fits.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-divis.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-divis_2exp.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-cong.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-cong_2exp.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-sizeinbase.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-set_str.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-aorsmul.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-cmp_d.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-cmp_si.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-hamdist.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-oddeven.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-popcount.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-set_f.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-io_raw.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-import.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-export.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-pprime_p.c ..\tests.lib ..\%LIBS%

t-addsub
t-cmp
t-mul
t-mul_i
t-tdiv
t-tdiv_ui
t-fdiv
t-fdiv_ui
t-cdiv_ui
t-gcd
t-gcd_ui
t-lcm
dive
dive_ui
t-sqrtrem
convert
io
t-inp_str
logic
bit
t-powm
t-powm_ui
t-pow
t-div_2exp
reuse
t-root
t-perfsqr
t-jac
t-bin
t-get_d
t-get_d_2exp
t-get_si
t-set_d
t-set_si
t-fac_ui
t-fib_ui
t-lucnum_ui
t-scan
t-fits
t-divis
t-divis_2exp
t-cong
t-cong_2exp
t-sizeinbase
t-set_str
t-aorsmul
t-cmp_d
t-cmp_si
t-hamdist
t-oddeven
t-popcount
t-set_f
t-io_raw
t-import
t-export
t-pprime_p

cd ../mpq
echo Entering directory tests/mpq
cl %CFLAGS% -I../.. t-aors.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-cmp.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-cmp_ui.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-cmp_si.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-equal.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-get_d.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-get_str.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-inp_str.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-md_2exp.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-set_f.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-set_str.c ..\tests.lib ..\%LIBS%

t-aors
t-cmp
t-cmp_ui
t-cmp_si
t-equal
t-get_d
t-get_str
t-inp_str
t-md_2exp
t-set_f
t-set_str

cd ..\mpf
echo Entering directory tests/mpf
cl %CFLAGS% -I../.. t-add.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-sub.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-conv.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-sqrt.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-sqrt_ui.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-muldiv.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-dm2exp.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. reuse.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-cmp_d.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-cmp_si.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-div.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-fits.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-get_d.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-get_d_2exp.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-get_si.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-get_ui.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-gsprec.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-inp_str.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-int_p.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-mul_ui.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-set.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-set_q.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-set_si.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-set_ui.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-trunc.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-ui_div.c ..\tests.lib ..\%LIBS%

t-add
t-sub
t-conv
t-sqrt
t-sqrt_ui
t-muldiv
t-dm2exp
reuse
t-cmp_d
t-cmp_si
t-div
t-fits
t-get_d
t-get_d_2exp
t-get_si
t-get_ui
t-gsprec
t-inp_str
t-int_p
t-mul_ui
t-set
t-set_q
t-set_si
t-set_ui
t-trunc
t-ui_div


cd ..\rand
echo Entering directory tests/rand
cl %CFLAGS% -I../.. t-iset.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-lc2exp.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-mt.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-rand.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-urbui.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-urmui.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-urndmm.c ..\tests.lib ..\%LIBS%

t-iset
t-lc2exp
t-mt
t-rand
t-urbui
t-urmui
t-urndmm

cd ..\misc
echo Entering directory tests/misc
cl %CFLAGS% -I../.. /D intmax_t=__int64 t-printf.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. /D intmax_t=__int64 t-scanf.c ..\tests.lib ..\%LIBS%
cl %CFLAGS% -I../.. t-locale.c ..\tests.lib ..\%LIBS%

t-printf
t-scanf
t-locale

cd ..\..
